/* GestureAnimationDirector.c generated by valac 0.48.13, the Vala compiler
 * generated from GestureAnimationDirector.vala, do not modify */

/*
 * Copyright 2020 elementary, Inc (https://elementary.io)
 *           2020 José Expósito <jose.exposito89@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define GALA_TYPE_GESTURE_ANIMATION_DIRECTOR (gala_gesture_animation_director_get_type ())
#define GALA_GESTURE_ANIMATION_DIRECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, GalaGestureAnimationDirector))
#define GALA_GESTURE_ANIMATION_DIRECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, GalaGestureAnimationDirectorClass))
#define GALA_IS_GESTURE_ANIMATION_DIRECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_ANIMATION_DIRECTOR))
#define GALA_IS_GESTURE_ANIMATION_DIRECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_ANIMATION_DIRECTOR))
#define GALA_GESTURE_ANIMATION_DIRECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, GalaGestureAnimationDirectorClass))

typedef struct _GalaGestureAnimationDirector GalaGestureAnimationDirector;
typedef struct _GalaGestureAnimationDirectorClass GalaGestureAnimationDirectorClass;
typedef struct _GalaGestureAnimationDirectorPrivate GalaGestureAnimationDirectorPrivate;
enum  {
	GALA_GESTURE_ANIMATION_DIRECTOR_0_PROPERTY,
	GALA_GESTURE_ANIMATION_DIRECTOR_MIN_ANIMATION_DURATION_PROPERTY,
	GALA_GESTURE_ANIMATION_DIRECTOR_MAX_ANIMATION_DURATION_PROPERTY,
	GALA_GESTURE_ANIMATION_DIRECTOR_RUNNING_PROPERTY,
	GALA_GESTURE_ANIMATION_DIRECTOR_CANCELING_PROPERTY,
	GALA_GESTURE_ANIMATION_DIRECTOR_NUM_PROPERTIES
};
static GParamSpec* gala_gesture_animation_director_properties[GALA_GESTURE_ANIMATION_DIRECTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef void (*GalaGestureAnimationDirectorOnBegin) (gdouble percentage, gpointer user_data);
typedef void (*GalaGestureAnimationDirectorOnUpdate) (gdouble percentage, gpointer user_data);
typedef void (*GalaGestureAnimationDirectorOnEnd) (gdouble percentage, gboolean cancel_action, gint calculated_duration, gpointer user_data);
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GALA_GESTURE_ANIMATION_DIRECTOR_ON_ANIMATION_BEGIN_SIGNAL,
	GALA_GESTURE_ANIMATION_DIRECTOR_ON_ANIMATION_UPDATE_SIGNAL,
	GALA_GESTURE_ANIMATION_DIRECTOR_ON_ANIMATION_END_SIGNAL,
	GALA_GESTURE_ANIMATION_DIRECTOR_NUM_SIGNALS
};
static guint gala_gesture_animation_director_signals[GALA_GESTURE_ANIMATION_DIRECTOR_NUM_SIGNALS] = {0};

struct _GalaGestureAnimationDirector {
	GObject parent_instance;
	GalaGestureAnimationDirectorPrivate * priv;
};

struct _GalaGestureAnimationDirectorClass {
	GObjectClass parent_class;
};

struct _GalaGestureAnimationDirectorPrivate {
	gint _min_animation_duration;
	gint _max_animation_duration;
	gboolean _running;
	gboolean _canceling;
	GeeArrayList* handlers;
	gdouble previous_percentage;
	guint64 previous_time;
	gdouble percentage_delta;
	gdouble velocity;
};

struct _Block3Data {
	int _ref_count_;
	GalaGestureAnimationDirector* self;
	GalaGestureAnimationDirectorOnBegin on_begin;
	gpointer on_begin_target;
	GDestroyNotify on_begin_target_destroy_notify;
	GalaGestureAnimationDirectorOnUpdate on_update;
	gpointer on_update_target;
	GDestroyNotify on_update_target_destroy_notify;
	GalaGestureAnimationDirectorOnEnd on_end;
	gpointer on_end_target;
	GDestroyNotify on_end_target_destroy_notify;
};

static gint GalaGestureAnimationDirector_private_offset;
static gpointer gala_gesture_animation_director_parent_class = NULL;

GType gala_gesture_animation_director_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureAnimationDirector, g_object_unref)
#define GALA_GESTURE_ANIMATION_DIRECTOR_SUCCESS_PERCENTAGE_THRESHOLD 20
#define GALA_GESTURE_ANIMATION_DIRECTOR_SUCCESS_VELOCITY_THRESHOLD 0.3
#define GALA_GESTURE_ANIMATION_DIRECTOR_ANIMATION_BASE_VELOCITY 0.002
#define GALA_GESTURE_ANIMATION_DIRECTOR_MAX_VELOCITY 0.5
GalaGestureAnimationDirector* gala_gesture_animation_director_new (gint min_animation_duration,
                                                                   gint max_animation_duration);
GalaGestureAnimationDirector* gala_gesture_animation_director_construct (GType object_type,
                                                                         gint min_animation_duration,
                                                                         gint max_animation_duration);
void gala_gesture_animation_director_connect_handlers (GalaGestureAnimationDirector* self,
                                                       GalaGestureAnimationDirectorOnBegin on_begin,
                                                       gpointer on_begin_target,
                                                       GDestroyNotify on_begin_target_destroy_notify,
                                                       GalaGestureAnimationDirectorOnUpdate on_update,
                                                       gpointer on_update_target,
                                                       GDestroyNotify on_update_target_destroy_notify,
                                                       GalaGestureAnimationDirectorOnEnd on_end,
                                                       gpointer on_end_target,
                                                       GDestroyNotify on_end_target_destroy_notify);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ___lambda42_ (Block3Data* _data3_,
                   gdouble percentage);
static void ____lambda42__gala_gesture_animation_director_on_animation_begin (GalaGestureAnimationDirector* _sender,
                                                                       gdouble percentage,
                                                                       gpointer self);
static void ___lambda43_ (Block3Data* _data3_,
                   gdouble percentage);
static void ____lambda43__gala_gesture_animation_director_on_animation_update (GalaGestureAnimationDirector* _sender,
                                                                        gdouble percentage,
                                                                        gpointer self);
static void ___lambda44_ (Block3Data* _data3_,
                   gdouble percentage,
                   gboolean cancel_action,
                   gint duration);
static void ____lambda44__gala_gesture_animation_director_on_animation_end (GalaGestureAnimationDirector* _sender,
                                                                     gdouble percentage,
                                                                     gboolean cancel_action,
                                                                     gint calculated_duration,
                                                                     gpointer self);
void gala_gesture_animation_director_disconnect_all_handlers (GalaGestureAnimationDirector* self);
gfloat gala_gesture_animation_director_animation_value (gfloat initial_value,
                                                        gfloat target_value,
                                                        gdouble percentage,
                                                        gboolean rounded);
gint gala_internal_utils_get_ui_scaling_factor (void);
void gala_gesture_animation_director_update_animation (GalaGestureAnimationDirector* self,
                                                       GHashTable* hints);
static void gala_gesture_animation_director_update_animation_begin (GalaGestureAnimationDirector* self,
                                                             gdouble percentage,
                                                             guint64 elapsed_time);
static void gala_gesture_animation_director_update_animation_update (GalaGestureAnimationDirector* self,
                                                              gdouble percentage,
                                                              guint64 elapsed_time);
static void gala_gesture_animation_director_update_animation_end (GalaGestureAnimationDirector* self,
                                                           gdouble percentage,
                                                           guint64 elapsed_time);
static gdouble gala_gesture_animation_director_applied_percentage (gdouble percentage,
                                                            gdouble percentage_delta);
static gint gala_gesture_animation_director_calculate_end_animation_duration (GalaGestureAnimationDirector* self,
                                                                       gdouble end_percentage,
                                                                       gboolean cancel_action);
gint gala_gesture_animation_director_get_min_animation_duration (GalaGestureAnimationDirector* self);
gint gala_gesture_animation_director_get_max_animation_duration (GalaGestureAnimationDirector* self);
static void gala_gesture_animation_director_set_min_animation_duration (GalaGestureAnimationDirector* self,
                                                                 gint value);
static void gala_gesture_animation_director_set_max_animation_duration (GalaGestureAnimationDirector* self,
                                                                 gint value);
gboolean gala_gesture_animation_director_get_running (GalaGestureAnimationDirector* self);
void gala_gesture_animation_director_set_running (GalaGestureAnimationDirector* self,
                                                  gboolean value);
gboolean gala_gesture_animation_director_get_canceling (GalaGestureAnimationDirector* self);
void gala_gesture_animation_director_set_canceling (GalaGestureAnimationDirector* self,
                                                    gboolean value);
static void g_cclosure_user_marshal_VOID__DOUBLE_BOOLEAN_INT (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static GObject * gala_gesture_animation_director_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static void gala_gesture_animation_director_finalize (GObject * obj);
static GType gala_gesture_animation_director_get_type_once (void);
static void _vala_gala_gesture_animation_director_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_gala_gesture_animation_director_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);

static inline gpointer
gala_gesture_animation_director_get_instance_private (GalaGestureAnimationDirector* self)
{
	return G_STRUCT_MEMBER_P (self, GalaGestureAnimationDirector_private_offset);
}

GalaGestureAnimationDirector*
gala_gesture_animation_director_construct (GType object_type,
                                           gint min_animation_duration,
                                           gint max_animation_duration)
{
	GalaGestureAnimationDirector * self = NULL;
	self = (GalaGestureAnimationDirector*) g_object_new (object_type, "min-animation-duration", min_animation_duration, "max-animation-duration", max_animation_duration, NULL);
	return self;
}

GalaGestureAnimationDirector*
gala_gesture_animation_director_new (gint min_animation_duration,
                                     gint max_animation_duration)
{
	return gala_gesture_animation_director_construct (GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, min_animation_duration, max_animation_duration);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		GalaGestureAnimationDirector* self;
		self = _data3_->self;
		(_data3_->on_begin_target_destroy_notify == NULL) ? NULL : (_data3_->on_begin_target_destroy_notify (_data3_->on_begin_target), NULL);
		_data3_->on_begin = NULL;
		_data3_->on_begin_target = NULL;
		_data3_->on_begin_target_destroy_notify = NULL;
		(_data3_->on_update_target_destroy_notify == NULL) ? NULL : (_data3_->on_update_target_destroy_notify (_data3_->on_update_target), NULL);
		_data3_->on_update = NULL;
		_data3_->on_update_target = NULL;
		_data3_->on_update_target_destroy_notify = NULL;
		(_data3_->on_end_target_destroy_notify == NULL) ? NULL : (_data3_->on_end_target_destroy_notify (_data3_->on_end_target), NULL);
		_data3_->on_end = NULL;
		_data3_->on_end_target = NULL;
		_data3_->on_end_target_destroy_notify = NULL;
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
___lambda42_ (Block3Data* _data3_,
              gdouble percentage)
{
	GalaGestureAnimationDirector* self;
	self = _data3_->self;
	_data3_->on_begin (percentage, _data3_->on_begin_target);
}

static void
____lambda42__gala_gesture_animation_director_on_animation_begin (GalaGestureAnimationDirector* _sender,
                                                                  gdouble percentage,
                                                                  gpointer self)
{
	___lambda42_ (self, percentage);
}

static void
___lambda43_ (Block3Data* _data3_,
              gdouble percentage)
{
	GalaGestureAnimationDirector* self;
	self = _data3_->self;
	_data3_->on_update (percentage, _data3_->on_update_target);
}

static void
____lambda43__gala_gesture_animation_director_on_animation_update (GalaGestureAnimationDirector* _sender,
                                                                   gdouble percentage,
                                                                   gpointer self)
{
	___lambda43_ (self, percentage);
}

static void
___lambda44_ (Block3Data* _data3_,
              gdouble percentage,
              gboolean cancel_action,
              gint duration)
{
	GalaGestureAnimationDirector* self;
	self = _data3_->self;
	_data3_->on_end (percentage, cancel_action, duration, _data3_->on_end_target);
}

static void
____lambda44__gala_gesture_animation_director_on_animation_end (GalaGestureAnimationDirector* _sender,
                                                                gdouble percentage,
                                                                gboolean cancel_action,
                                                                gint calculated_duration,
                                                                gpointer self)
{
	___lambda44_ (self, percentage, cancel_action, calculated_duration);
}

void
gala_gesture_animation_director_connect_handlers (GalaGestureAnimationDirector* self,
                                                  GalaGestureAnimationDirectorOnBegin on_begin,
                                                  gpointer on_begin_target,
                                                  GDestroyNotify on_begin_target_destroy_notify,
                                                  GalaGestureAnimationDirectorOnUpdate on_update,
                                                  gpointer on_update_target,
                                                  GDestroyNotify on_update_target_destroy_notify,
                                                  GalaGestureAnimationDirectorOnEnd on_end,
                                                  gpointer on_end_target,
                                                  GDestroyNotify on_end_target_destroy_notify)
{
	Block3Data* _data3_;
	g_return_if_fail (self != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	(_data3_->on_begin_target_destroy_notify == NULL) ? NULL : (_data3_->on_begin_target_destroy_notify (_data3_->on_begin_target), NULL);
	_data3_->on_begin = NULL;
	_data3_->on_begin_target = NULL;
	_data3_->on_begin_target_destroy_notify = NULL;
	_data3_->on_begin = on_begin;
	_data3_->on_begin_target = on_begin_target;
	_data3_->on_begin_target_destroy_notify = on_begin_target_destroy_notify;
	(_data3_->on_update_target_destroy_notify == NULL) ? NULL : (_data3_->on_update_target_destroy_notify (_data3_->on_update_target), NULL);
	_data3_->on_update = NULL;
	_data3_->on_update_target = NULL;
	_data3_->on_update_target_destroy_notify = NULL;
	_data3_->on_update = on_update;
	_data3_->on_update_target = on_update_target;
	_data3_->on_update_target_destroy_notify = on_update_target_destroy_notify;
	(_data3_->on_end_target_destroy_notify == NULL) ? NULL : (_data3_->on_end_target_destroy_notify (_data3_->on_end_target), NULL);
	_data3_->on_end = NULL;
	_data3_->on_end_target = NULL;
	_data3_->on_end_target_destroy_notify = NULL;
	_data3_->on_end = on_end;
	_data3_->on_end_target = on_end_target;
	_data3_->on_end_target_destroy_notify = on_end_target_destroy_notify;
	if (_data3_->on_begin != NULL) {
		gulong handler_id = 0UL;
		gulong _tmp0_;
		GeeArrayList* _tmp1_;
		_tmp0_ = g_signal_connect_data (self, "on-animation-begin", (GCallback) ____lambda42__gala_gesture_animation_director_on_animation_begin, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
		handler_id = _tmp0_;
		_tmp1_ = self->priv->handlers;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (gpointer) ((guintptr) handler_id));
	}
	if (_data3_->on_update != NULL) {
		gulong handler_id = 0UL;
		gulong _tmp2_;
		GeeArrayList* _tmp3_;
		_tmp2_ = g_signal_connect_data (self, "on-animation-update", (GCallback) ____lambda43__gala_gesture_animation_director_on_animation_update, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
		handler_id = _tmp2_;
		_tmp3_ = self->priv->handlers;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, (gpointer) ((guintptr) handler_id));
	}
	if (_data3_->on_end != NULL) {
		gulong handler_id = 0UL;
		gulong _tmp4_;
		GeeArrayList* _tmp5_;
		_tmp4_ = g_signal_connect_data (self, "on-animation-end", (GCallback) ____lambda44__gala_gesture_animation_director_on_animation_end, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
		handler_id = _tmp4_;
		_tmp5_ = self->priv->handlers;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, (gpointer) ((guintptr) handler_id));
	}
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
gala_gesture_animation_director_disconnect_all_handlers (GalaGestureAnimationDirector* self)
{
	GeeArrayList* _tmp9_;
	g_return_if_fail (self != NULL);
	{
		GeeArrayList* _handler_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _handler_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _handler_index = 0;
		_tmp0_ = self->priv->handlers;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_handler_list = _tmp1_;
		_tmp2_ = _handler_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_handler_size = _tmp4_;
		_handler_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gulong handler = 0UL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			_handler_index = _handler_index + 1;
			_tmp5_ = _handler_index;
			_tmp6_ = _handler_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _handler_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _handler_index);
			handler = (gulong) ((guintptr) _tmp8_);
			g_signal_handler_disconnect ((GObject*) self, handler);
		}
		_g_object_unref0 (_handler_list);
	}
	_tmp9_ = self->priv->handlers;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp9_);
}

/**
     * Utility method to calculate the current animation value based on the percentage of the
     * gesture performed.
     * Animations are always linear, as they are 1:1 to the user's movement.
     * @param initial_value Animation start value.
     * @param target_value Animation end value.
     * @param percentage Current animation percentage.
     * @param rounded If the returned value should be rounded to match physical pixels.
     * Default to false because some animations, like for example scaling an actor, use intermediate
     * values not divisible by physical pixels.
     * @returns The linear animation value at the specified percentage.
     */
gfloat
gala_gesture_animation_director_animation_value (gfloat initial_value,
                                                 gfloat target_value,
                                                 gdouble percentage,
                                                 gboolean rounded)
{
	gfloat value = 0.0F;
	gfloat result = 0.0F;
	value = (((target_value - initial_value) * ((gfloat) percentage)) / 100) + initial_value;
	if (rounded) {
		gint scale_factor = 0;
		scale_factor = gala_internal_utils_get_ui_scaling_factor ();
		value = ((gfloat) round ((gdouble) (value * scale_factor))) / scale_factor;
	}
	result = value;
	return result;
}

void
gala_gesture_animation_director_update_animation (GalaGestureAnimationDirector* self,
                                                  GHashTable* hints)
{
	gchar* event = NULL;
	gconstpointer _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gdouble percentage = 0.0;
	gconstpointer _tmp3_;
	guint64 elapsed_time = 0ULL;
	gconstpointer _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GQuark _tmp8_ = 0U;
	static GQuark _tmp7_label0 = 0;
	static GQuark _tmp7_label1 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (hints != NULL);
	_tmp0_ = g_hash_table_lookup (hints, "event");
	_tmp1_ = g_variant_get_string ((GVariant*) _tmp0_, NULL);
	_tmp2_ = g_strdup (_tmp1_);
	event = _tmp2_;
	_tmp3_ = g_hash_table_lookup (hints, "percentage");
	percentage = g_variant_get_double ((GVariant*) _tmp3_);
	_tmp4_ = g_hash_table_lookup (hints, "elapsed_time");
	elapsed_time = g_variant_get_uint64 ((GVariant*) _tmp4_);
	_tmp5_ = event;
	_tmp6_ = _tmp5_;
	_tmp8_ = (NULL == _tmp6_) ? 0 : g_quark_from_string (_tmp6_);
	if (_tmp8_ == ((0 != _tmp7_label0) ? _tmp7_label0 : (_tmp7_label0 = g_quark_from_static_string ("begin")))) {
		switch (0) {
			default:
			{
				gala_gesture_animation_director_update_animation_begin (self, percentage, elapsed_time);
				break;
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label1) ? _tmp7_label1 : (_tmp7_label1 = g_quark_from_static_string ("update")))) {
		switch (0) {
			default:
			{
				gala_gesture_animation_director_update_animation_update (self, percentage, elapsed_time);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				gala_gesture_animation_director_update_animation_end (self, percentage, elapsed_time);
				break;
			}
		}
	}
	_g_free0 (event);
}

static void
gala_gesture_animation_director_update_animation_begin (GalaGestureAnimationDirector* self,
                                                        gdouble percentage,
                                                        guint64 elapsed_time)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gala_gesture_animation_director_signals[GALA_GESTURE_ANIMATION_DIRECTOR_ON_ANIMATION_BEGIN_SIGNAL], 0, percentage);
	self->priv->previous_percentage = percentage;
	self->priv->previous_time = elapsed_time;
}

static void
gala_gesture_animation_director_update_animation_update (GalaGestureAnimationDirector* self,
                                                         gdouble percentage,
                                                         guint64 elapsed_time)
{
	g_return_if_fail (self != NULL);
	if (elapsed_time != self->priv->previous_time) {
		gdouble distance = 0.0;
		gdouble time = 0.0;
		distance = percentage - self->priv->previous_percentage;
		time = (gdouble) (elapsed_time - self->priv->previous_time);
		self->priv->velocity = distance / time;
		if (self->priv->velocity > GALA_GESTURE_ANIMATION_DIRECTOR_MAX_VELOCITY) {
			gdouble used_percentage = 0.0;
			self->priv->velocity = GALA_GESTURE_ANIMATION_DIRECTOR_MAX_VELOCITY;
			used_percentage = (GALA_GESTURE_ANIMATION_DIRECTOR_MAX_VELOCITY * time) + self->priv->previous_percentage;
			self->priv->percentage_delta = self->priv->percentage_delta + (percentage - used_percentage);
		}
	}
	g_signal_emit (self, gala_gesture_animation_director_signals[GALA_GESTURE_ANIMATION_DIRECTOR_ON_ANIMATION_UPDATE_SIGNAL], 0, gala_gesture_animation_director_applied_percentage (percentage, self->priv->percentage_delta));
	self->priv->previous_percentage = percentage;
	self->priv->previous_time = elapsed_time;
}

static void
gala_gesture_animation_director_update_animation_end (GalaGestureAnimationDirector* self,
                                                      gdouble percentage,
                                                      guint64 elapsed_time)
{
	gdouble end_percentage = 0.0;
	gboolean _tmp0_ = FALSE;
	gboolean cancel_action = FALSE;
	gint calculated_duration = 0;
	g_return_if_fail (self != NULL);
	end_percentage = gala_gesture_animation_director_applied_percentage (percentage, self->priv->percentage_delta);
	if (end_percentage < ((gdouble) GALA_GESTURE_ANIMATION_DIRECTOR_SUCCESS_PERCENTAGE_THRESHOLD)) {
		gboolean _tmp1_ = FALSE;
		if (end_percentage <= self->priv->previous_percentage) {
			_tmp1_ = self->priv->velocity < GALA_GESTURE_ANIMATION_DIRECTOR_SUCCESS_VELOCITY_THRESHOLD;
		} else {
			_tmp1_ = FALSE;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	cancel_action = _tmp0_;
	calculated_duration = gala_gesture_animation_director_calculate_end_animation_duration (self, end_percentage, cancel_action);
	g_signal_emit (self, gala_gesture_animation_director_signals[GALA_GESTURE_ANIMATION_DIRECTOR_ON_ANIMATION_END_SIGNAL], 0, end_percentage, cancel_action, calculated_duration);
	self->priv->previous_percentage = (gdouble) 0;
	self->priv->previous_time = (guint64) 0;
	self->priv->percentage_delta = (gdouble) 0;
	self->priv->velocity = (gdouble) 0;
}

static gdouble
gala_gesture_animation_director_applied_percentage (gdouble percentage,
                                                    gdouble percentage_delta)
{
	gdouble result = 0.0;
	result = CLAMP (percentage - percentage_delta, (gdouble) 0, (gdouble) 100);
	return result;
}

/**
     * Calculates the end animation duration using the current gesture velocity.
     */
static gint
gala_gesture_animation_director_calculate_end_animation_duration (GalaGestureAnimationDirector* self,
                                                                  gdouble end_percentage,
                                                                  gboolean cancel_action)
{
	gdouble _tmp0_ = 0.0;
	gdouble animation_velocity = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble pending_percentage = 0.0;
	gint duration = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (self->priv->velocity > GALA_GESTURE_ANIMATION_DIRECTOR_ANIMATION_BASE_VELOCITY) {
		_tmp0_ = self->priv->velocity;
	} else {
		_tmp0_ = GALA_GESTURE_ANIMATION_DIRECTOR_ANIMATION_BASE_VELOCITY;
	}
	animation_velocity = _tmp0_;
	if (cancel_action) {
		_tmp1_ = end_percentage;
	} else {
		_tmp1_ = 100 - end_percentage;
	}
	pending_percentage = _tmp1_;
	_tmp2_ = self->priv->_min_animation_duration;
	_tmp3_ = self->priv->_max_animation_duration;
	duration = CLAMP ((gint) fabs (pending_percentage / animation_velocity), _tmp2_, _tmp3_);
	result = duration;
	return result;
}

gint
gala_gesture_animation_director_get_min_animation_duration (GalaGestureAnimationDirector* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_min_animation_duration;
	return result;
}

static void
gala_gesture_animation_director_set_min_animation_duration (GalaGestureAnimationDirector* self,
                                                            gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_gesture_animation_director_get_min_animation_duration (self);
	if (old_value != value) {
		self->priv->_min_animation_duration = value;
		g_object_notify_by_pspec ((GObject *) self, gala_gesture_animation_director_properties[GALA_GESTURE_ANIMATION_DIRECTOR_MIN_ANIMATION_DURATION_PROPERTY]);
	}
}

gint
gala_gesture_animation_director_get_max_animation_duration (GalaGestureAnimationDirector* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_max_animation_duration;
	return result;
}

static void
gala_gesture_animation_director_set_max_animation_duration (GalaGestureAnimationDirector* self,
                                                            gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_gesture_animation_director_get_max_animation_duration (self);
	if (old_value != value) {
		self->priv->_max_animation_duration = value;
		g_object_notify_by_pspec ((GObject *) self, gala_gesture_animation_director_properties[GALA_GESTURE_ANIMATION_DIRECTOR_MAX_ANIMATION_DURATION_PROPERTY]);
	}
}

gboolean
gala_gesture_animation_director_get_running (GalaGestureAnimationDirector* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_running;
	return result;
}

void
gala_gesture_animation_director_set_running (GalaGestureAnimationDirector* self,
                                             gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_gesture_animation_director_get_running (self);
	if (old_value != value) {
		self->priv->_running = value;
		g_object_notify_by_pspec ((GObject *) self, gala_gesture_animation_director_properties[GALA_GESTURE_ANIMATION_DIRECTOR_RUNNING_PROPERTY]);
	}
}

gboolean
gala_gesture_animation_director_get_canceling (GalaGestureAnimationDirector* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_canceling;
	return result;
}

void
gala_gesture_animation_director_set_canceling (GalaGestureAnimationDirector* self,
                                               gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_gesture_animation_director_get_canceling (self);
	if (old_value != value) {
		self->priv->_canceling = value;
		g_object_notify_by_pspec ((GObject *) self, gala_gesture_animation_director_properties[GALA_GESTURE_ANIMATION_DIRECTOR_CANCELING_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_BOOLEAN_INT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_BOOLEAN_INT) (gpointer data1, gdouble arg_1, gboolean arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_BOOLEAN_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DOUBLE_BOOLEAN_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_double (param_values + 1), g_value_get_boolean (param_values + 2), g_value_get_int (param_values + 3), data2);
}

static GObject *
gala_gesture_animation_director_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaGestureAnimationDirector * self;
	GeeArrayList* _tmp0_;
	parent_class = G_OBJECT_CLASS (gala_gesture_animation_director_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, GalaGestureAnimationDirector);
	_tmp0_ = gee_array_list_new (G_TYPE_ULONG, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->handlers);
	self->priv->handlers = _tmp0_;
	self->priv->previous_percentage = (gdouble) 0;
	self->priv->previous_time = (guint64) 0;
	self->priv->percentage_delta = (gdouble) 0;
	self->priv->velocity = (gdouble) 0;
	return obj;
}

static void
gala_gesture_animation_director_class_init (GalaGestureAnimationDirectorClass * klass,
                                            gpointer klass_data)
{
	gala_gesture_animation_director_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaGestureAnimationDirector_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_gesture_animation_director_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_gesture_animation_director_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_gesture_animation_director_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_gesture_animation_director_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_GESTURE_ANIMATION_DIRECTOR_MIN_ANIMATION_DURATION_PROPERTY, gala_gesture_animation_director_properties[GALA_GESTURE_ANIMATION_DIRECTOR_MIN_ANIMATION_DURATION_PROPERTY] = g_param_spec_int ("min-animation-duration", "min-animation-duration", "min-animation-duration", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_GESTURE_ANIMATION_DIRECTOR_MAX_ANIMATION_DURATION_PROPERTY, gala_gesture_animation_director_properties[GALA_GESTURE_ANIMATION_DIRECTOR_MAX_ANIMATION_DURATION_PROPERTY] = g_param_spec_int ("max-animation-duration", "max-animation-duration", "max-animation-duration", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_GESTURE_ANIMATION_DIRECTOR_RUNNING_PROPERTY, gala_gesture_animation_director_properties[GALA_GESTURE_ANIMATION_DIRECTOR_RUNNING_PROPERTY] = g_param_spec_boolean ("running", "running", "running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_GESTURE_ANIMATION_DIRECTOR_CANCELING_PROPERTY, gala_gesture_animation_director_properties[GALA_GESTURE_ANIMATION_DIRECTOR_CANCELING_PROPERTY] = g_param_spec_boolean ("canceling", "canceling", "canceling", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gala_gesture_animation_director_signals[GALA_GESTURE_ANIMATION_DIRECTOR_ON_ANIMATION_BEGIN_SIGNAL] = g_signal_new ("on-animation-begin", GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	gala_gesture_animation_director_signals[GALA_GESTURE_ANIMATION_DIRECTOR_ON_ANIMATION_UPDATE_SIGNAL] = g_signal_new ("on-animation-update", GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	gala_gesture_animation_director_signals[GALA_GESTURE_ANIMATION_DIRECTOR_ON_ANIMATION_END_SIGNAL] = g_signal_new ("on-animation-end", GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_BOOLEAN_INT, G_TYPE_NONE, 3, G_TYPE_DOUBLE, G_TYPE_BOOLEAN, G_TYPE_INT);
}

static void
gala_gesture_animation_director_instance_init (GalaGestureAnimationDirector * self,
                                               gpointer klass)
{
	self->priv = gala_gesture_animation_director_get_instance_private (self);
	self->priv->_running = FALSE;
	self->priv->_canceling = FALSE;
}

static void
gala_gesture_animation_director_finalize (GObject * obj)
{
	GalaGestureAnimationDirector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, GalaGestureAnimationDirector);
	_g_object_unref0 (self->priv->handlers);
	G_OBJECT_CLASS (gala_gesture_animation_director_parent_class)->finalize (obj);
}

static GType
gala_gesture_animation_director_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaGestureAnimationDirectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_gesture_animation_director_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaGestureAnimationDirector), 0, (GInstanceInitFunc) gala_gesture_animation_director_instance_init, NULL };
	GType gala_gesture_animation_director_type_id;
	gala_gesture_animation_director_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaGestureAnimationDirector", &g_define_type_info, 0);
	GalaGestureAnimationDirector_private_offset = g_type_add_instance_private (gala_gesture_animation_director_type_id, sizeof (GalaGestureAnimationDirectorPrivate));
	return gala_gesture_animation_director_type_id;
}

GType
gala_gesture_animation_director_get_type (void)
{
	static volatile gsize gala_gesture_animation_director_type_id__volatile = 0;
	if (g_once_init_enter (&gala_gesture_animation_director_type_id__volatile)) {
		GType gala_gesture_animation_director_type_id;
		gala_gesture_animation_director_type_id = gala_gesture_animation_director_get_type_once ();
		g_once_init_leave (&gala_gesture_animation_director_type_id__volatile, gala_gesture_animation_director_type_id);
	}
	return gala_gesture_animation_director_type_id__volatile;
}

static void
_vala_gala_gesture_animation_director_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	GalaGestureAnimationDirector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, GalaGestureAnimationDirector);
	switch (property_id) {
		case GALA_GESTURE_ANIMATION_DIRECTOR_MIN_ANIMATION_DURATION_PROPERTY:
		g_value_set_int (value, gala_gesture_animation_director_get_min_animation_duration (self));
		break;
		case GALA_GESTURE_ANIMATION_DIRECTOR_MAX_ANIMATION_DURATION_PROPERTY:
		g_value_set_int (value, gala_gesture_animation_director_get_max_animation_duration (self));
		break;
		case GALA_GESTURE_ANIMATION_DIRECTOR_RUNNING_PROPERTY:
		g_value_set_boolean (value, gala_gesture_animation_director_get_running (self));
		break;
		case GALA_GESTURE_ANIMATION_DIRECTOR_CANCELING_PROPERTY:
		g_value_set_boolean (value, gala_gesture_animation_director_get_canceling (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gala_gesture_animation_director_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	GalaGestureAnimationDirector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_GESTURE_ANIMATION_DIRECTOR, GalaGestureAnimationDirector);
	switch (property_id) {
		case GALA_GESTURE_ANIMATION_DIRECTOR_MIN_ANIMATION_DURATION_PROPERTY:
		gala_gesture_animation_director_set_min_animation_duration (self, g_value_get_int (value));
		break;
		case GALA_GESTURE_ANIMATION_DIRECTOR_MAX_ANIMATION_DURATION_PROPERTY:
		gala_gesture_animation_director_set_max_animation_duration (self, g_value_get_int (value));
		break;
		case GALA_GESTURE_ANIMATION_DIRECTOR_RUNNING_PROPERTY:
		gala_gesture_animation_director_set_running (self, g_value_get_boolean (value));
		break;
		case GALA_GESTURE_ANIMATION_DIRECTOR_CANCELING_PROPERTY:
		gala_gesture_animation_director_set_canceling (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

